#include <Wire.h> 
#define I2CAddr 0x48 // ADT7410 のアドレス。

void setup(){ 
  // 9600bps でシリアルポート(USB)を開きます。 
  Serial.begin( 9600 ); 
  // I2C 通信を開始します。 
  Wire.begin(); 
  // Processing とのハンドシェイクを開始します。 
  while( Serial.available() <= 0 ){
    Serial.println( "0.0" ); 
    delay( 300 );
  }
}

void loop(){ 
  if( Serial.available() > 0 ){
    Serial.read();
    
    byte ddHigh, ddLow; // I2C デバイスからのデータ読み取り用変数。 
    int	dd;	// 読み取ったデータを整数化するための変数。 
    float dt;	// 整数データを温度に変換するための変数。 
    Wire.requestFrom(I2CAddr, 2); // センサーへデータ読み取りを要求。 
    ddHigh = Wire.read();	// データの読み出し ( 上位バイト )
    ddLow = Wire.read();	// データの読み出し ( 下位バイト ) 
    Wire.endTransmission( false ); // 接続を継続したまま通信を終了。 
    dd = word( ddHigh, ddLow ); // 読み取ったデータを整数化。 
    dd >>= 3;	// 整数化したデータを 16bit から 13bit に。 
    dt = (float)dd / 16.0; // 摂氏温度に変換。
    Serial.println( dt ); 
//    delay(100);	// 測定周期 (ms)
    delay(1000);	// 測定周期 (ms)
  }
}
