//フォトセンサーをArduinoに接続して、重力加速度を求めるスケッチ。
//計算・表示はg_Processingで行う。

unsigned long time1;  //A1用時間変数
unsigned long time2;  //A2用時間変数
unsigned long time3;  //B1用時間変数
unsigned long time4;  //B2用時間変数
int flag1 = 1;  //２番ピン（A1）用変数
int flag2 = 1;  //３番ピン（A2）用変数
int flag3 = 1;  //４番ピン（B1）用変数
int flag4 = 1;  //５番ピン（B2）用変数
String s1;  //time1用string変数
String s2;  //time2用string変数
String s3;  //time3用string変数
String s4;  //time4用string変数

void setup() {
  Serial.begin(9600);
  pinMode(2, INPUT);  //フォトセンサーA1を２番ピンに接続
  pinMode(3, INPUT);  //フォトセンサーA2を３番ピンに接続
  pinMode(4, INPUT);  //フォトセンサーB1を４番ピンに接続
  pinMode(5, INPUT);  //フォトセンサーB2を５番ピンに接続
  pinMode(12, OUTPUT);  //LEDを12番ピンに接続
}

void loop() {
  if (Serial.available()) {
    //Processingから"r”が送られてきたら実行（初期化処理）
    if (Serial.read() == 'r') {
      flag1 = 0;
      flag2 = 0;
      flag3 = 0;
      flag4 = 0;
      s1 = "";
      s2 = "";
      s3 = "";
      s4 = "";
      digitalWrite(12, HIGH);   //LED発光
    }
  }

  //センサーＡの設定 （センサーの光が遮られると'LOW'になる）
  if (flag1 == 0) {
    if (digitalRead(2) == LOW ) {
      time1 = micros();
      flag1 = 1;
    }
  }
  if (flag2 == 0) {
    if (digitalRead(3) == LOW) {
      time2 = micros();
      flag2 = 1;
    }
  }
  //センサーBの設定　（センサーの光が遮られると'LOW'になる）
  if (flag3 == 0) {
    if (digitalRead(4) == LOW)  {
      time3 = micros();
      flag3 = 1;
    }
  }
  if (flag4 == 0) {
    if (digitalRead(5) == LOW) {
      time4 = micros();
      flag4 = 1;
      digitalWrite(12, LOW);  //LED発光停止

      //全部通過したら送信
      if (flag1 == 1 && flag2 == 1 && flag3 == 1 && flag4 == 1 ) {
        s1 = String(time1 );
        s2 = String(time2 );
        s3 = String(time3);
        s4 = String(time4);
        Serial.println(s1 + "," + s2 + "," + s3 + "," + s4 + ",");
      }
    }
  }
}

